## supercollider 3.5.3~repack

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
project (SuperCollider)

include("SCVersion.txt")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}${PROJECT_VERSION_PATCH}")
message(STATUS "SuperCollider Version: ${PROJECT_VERSION}")

include(CTest)
enable_testing()

include (cmake_modules/FinalFile.cmake)

if (NOT CMAKE_BUILD_TYPE)
	message(STATUS "Build type defaulting to \"RelWithDebInfo\"")
	set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif()

if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
	message(WARNING "WARNING: IN-PLACE BUILDS ARE NOT RECOMMENDED - PLEASE USE A BUILD DIRECTORY")
endif()


set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules
                      ${CMAKE_MODULE_PATH})

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

if(APPLE)
	STRING(REGEX REPLACE "^.*MacOSX10.([0-9]+).*$" "\\1" MAC_OSX_SDK_VERSION  "${CMAKE_OSX_SYSROOT}")

	if(CMAKE_OSX_DEPLOYMENT_TARGET)
		if (CMAKE_OSX_DEPLOYMENT_TARGET GREATER 10.4)
			set(HID_UTIL_DIR "HID_Utilities")
		else()
			set(HID_UTIL_DIR "HID_Utilities_10_4")
		endif()
	else()
		if (${MAC_OSX_SDK_VERSION} GREATER 4)
			set(HID_UTIL_DIR "HID_Utilities")
		else()
			set(HID_UTIL_DIR "HID_Utilities_10_4")
		endif()
	endif()
	MESSAGE( STATUS "Using HID Utilities from folder '${HID_UTIL_DIR}'")
endif()

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
	set(LINUX 1)
endif()

#############################################
# Compiler flags etc

if (${CMAKE_COMPILER_IS_GNUCXX})
	exec_program(${CMAKE_CXX_COMPILER} ARGS -dumpversion OUTPUT_VARIABLE _gcc_version)

	add_definitions("-fschedule-insns2" "-fomit-frame-pointer")

	add_definitions("-Wreturn-type")

#	disabled for now: -ffast-math breaks avx intrinsics and -fsigned-zeros/-fno-associative-math are not available in some versions
#	if (${_gcc_version} VERSION_GREATER 4.0.99)
#		add_definitions("-ffast-math -fsigned-zeros -fno-associative-math")
#	endif()

	option(DSO_VISIBILITY "DSO visibility support for gcc" OFF)

	if (DSO_VISIBILITY)
		add_definitions(-fvisibility=hidden)
	endif()

	if(APPLE)
		exec_program(${CMAKE_CXX_COMPILER} ARGS --version OUTPUT_VARIABLE _gcc_version_info)
		if ("${_gcc_version_info}" MATCHES "Apple")
			add_definitions("-fpascal-strings")
		endif()
		add_definitions("-D_REENTRANT")
	elseif(NOT (WIN32 AND NOT CYGWIN))
		add_definitions("-pthread")
	endif()
endif ()

if (${CMAKE_CXX_COMPILER} MATCHES icpc)
	set(CMAKE_COMPILER_IS_INTEL 1)
	add_definitions(-Wno-unknown-pragmas)
	add_definitions(-simd)
endif()

if (${CMAKE_CXX_COMPILER} MATCHES clang)
	option(DSO_VISIBILITY "DSO visibility support for clang" OFF)

	if (DSO_VISIBILITY)
		add_definitions(-fvisibility=hidden)
	endif()

	set(CMAKE_COMPILER_IS_CLANG 1)
endif()

if(APPLE)
	set_property(DIRECTORY
		APPEND
		PROPERTY COMPILE_DEFINITIONS SC_DARWIN)
elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
	add_definitions("-DSC_LINUX")
	add_definitions(-DSC_DATA_DIR="${CMAKE_INSTALL_PREFIX}/share/SuperCollider")
elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
	add_definitions("-DSC_FREEBSD")
	add_definitions(-DSC_DATA_DIR="${CMAKE_INSTALL_PREFIX}/share/SuperCollider")
endif()

if(WIN32)
    set_property(DIRECTORY
                 APPEND
                 PROPERTY COMPILE_DEFINITIONS SC_WIN32 NOMINMAX _WIN32_WINNT=0x0500)

    add_definitions(-DWIN32_LEAN_AND_MEAN)

    if(MSVC)
        SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_RELEASE} /MTd")
        SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_DEBUG} /MT")
    endif()

    # correctly link the static Boost Thread library:
    add_definitions(-DBOOST_THREAD_USE_LIB)
endif()


#############################################
# Options
option(NOVA_SIMD "Build with nova-simd support." ON)
option(FINAL_BUILD "Build as single source file." OFF)

option(CURL "Build with curl for remote file download." ON)

option(FFT_GREEN "Use internal 'Green' FFT lib rather than FFTW. (Not recommended.)" OFF)

option(SSE "Compile with support for SSE instructions.")
option(SSE41 "Compile with support for SSE4.1 instructions.")
option(SSE42 "Compile with support for SSE4.2 instructions.")


option(INSTALL_HELP "Install help docs and examples along with the software" ON)
option(INSTALL_OLD_HELP "Install old and deprecated help files" ON)
option(SC_DOC_RENDER "Pre-render SCDoc documentation. (For putting online, etc)" OFF)

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    option(SUPERNOVA "Build with supernova as optional audio synthesis server" ON)
elseif()
    option(SUPERNOVA "Build with supernova as optional audio synthesis server" OFF)
endif()

option(SN_MEMORY_DEBUGGING "Build supernova for memory debugging (disable memory pools).")
option(SC_MEMORY_DEBUGGING "Build sclang&scsynth for memory debugging (disable memory pools).")
option(GC_SANITYCHECK "Enable sanity checks in the sclang garbage collector.")

option(NO_LIBSNDFILE "Disable soundfile functionality. (Not recommended.)" OFF)

option(NO_AVAHI "Disable Avahi support. (Not recommended.)" OFF)

option(SCLANG_SERVER "Build with internal server." ON)

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	option(SC_WII "Build sclang with WII support" ON)
endif()

option(SC_QT "Build SuperCollider with Qt GUI" ON)
if (SC_QT)
  message( STATUS "Compiling with Qt GUI" )
endif (SC_QT)

if(WIN32)
	option(SC_PSYCOLLIDER "Build PsyCollider" ON)
else()
	option(SC_PSYCOLLIDER "Build PsyCollider" OFF)
endif()

if(WIN32)
    option(SC_WIN_DEP_DIRS
        "A list of directories where dependencies will be searched for when packaging.")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
    option(NATIVE "Optimize binary for this architecture (binaries may not run on other machines, requires gcc-4.3 or higher).")
    option(LTO "Use GCC's link time optimizer' (experimental).")
endif()

option(SC_SYMLINK_CLASSLIB "Place a symlink of SCCLassLibrary instead of copying" OFF)
option(SC_OX "Try to compile with support for C++0x (experimental, mainly related to supernova)" OFF)

#############################################
# some default libraries

find_package(Pthreads)

if (NOT PTHREADS_FOUND)
    message(SEND_ERROR "cannot find libpthreads")
endif()
include_directories(${PTHREADS_INCLUDE_DIR})

if (MSVC OR MINGW)
    set(MATH_LIBRARY "")
else()
    find_library(MATH_LIBRARY m)
endif()

if(CURL)
	find_package(CURL)
	if(CURL_FOUND)
		add_definitions("-DHAVE_LIBCURL")
		include_directories(${CURL_INCLUDE_DIRS})
	endif()
endif()

set(Boost_USE_MULTITHREADED      ON)
find_package( Boost 1.48.0 COMPONENTS thread system filesystem program_options regex )

if (SC_OX)
	set(Boost_FOUND OFF) # boost 1.48 does not like c++11
endif()

if (Boost_FOUND)
	link_directories(${Boost_LIBRARY_DIRS})
else()
	message("building boost libraries manually")
endif()



#############################################
# some preprocessor flags
if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)
	if (SSE)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse -mfpmath=sse")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse -mfpmath=sse")
	endif()
	if (SSE41)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse4.1")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
	endif()
	if (SSE42)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse4.2")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2")
	endif()
	if (NATIVE)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=native")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
	endif()

	if (SC_OX)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
	endif()
endif()

if (CMAKE_COMPILER_IS_INTEL AND NOT WIN32)
	if (SSE42)
		add_definitions(-xSSE4.2)
	elseif (SSE41)
		add_definitions(-xSSE4.1)
	elseif (SSE)
		add_definitions(-mia32)
	endif()
	if (SC_OX)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
	endif()

	# disable warnings
	add_definitions(-diag-disable 170) # pointer points outside of underlying object ... used heavily in sclang
	add_definitions(-diag-disable 279) # controlling expression is constant

endif()

if (SC_MEMORY_DEBUGGING)
	add_definitions(-DDISABLE_MEMORY_POOLS)
endif()

#############################################
# subdirectories
add_subdirectory(external_libraries)
add_subdirectory(server)
add_subdirectory(lang)
add_subdirectory(bindings)
add_subdirectory(editors)
add_subdirectory(platform)

if(CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    install(DIRECTORY include/common include/plugin_interface include/server include/lang
        DESTINATION ${CMAKE_INSTALL_PREFIX}/include/SuperCollider
        FILES_MATCHING PATTERN "*.h"
    )
endif()

if(APPLE)
	# determines the app name and app install location (scappbundlename, scappdir):
	include (cmake_modules/MacAppFolder.cmake)

	set(auxresourcesdir ${scappauxresourcesdir})

	# Some aux files which go in the app's folder
	install(FILES README.txt ChangeLog COPYING AUTHORS platform/mac/MOVED_STUFF.txt
		DESTINATION ${scappbundlename}
	)
elseif (WIN32)
	set(auxresourcesdir "SuperCollider")
else()
	set(auxresourcesdir "share/SuperCollider")
endif()

set(SCCLASSLIB_EXCLUDE_REGEX "IGNOREME")

if(NOT SC_QT)
	set(SCCLASSLIB_EXCLUDE_REGEX "${SCCLASSLIB_EXCLUDE_REGEX}|QtCollider")
endif()

if(WIN32)
	set(SCCLASSLIB_EXCLUDE_REGEX "${SCCLASSLIB_EXCLUDE_REGEX}|PsycolliderDocument")
endif()


if(APPLE)

	if(SC_SYMLINK_CLASSLIB)

		#if there are folders inside SCCLassLibrary abort cmake.
		file(GLOB classlibraryfolders "${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary/[^.]*")
		foreach(onedirectory ${classlibraryfolders})
			message( "${onedirectory}" )
			if(NOT IS_SYMLINK "${onedirectory}")
				message(FATAL_ERROR "Symlinking will fail ! SCClassLibrary folder already exists and has directories inside, please delete it first." )
			endif()
		endforeach(onedirectory)

		message(STATUS "Will create symlink of SCClassLibrary to ${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary" )
		if(NOT EXISTS "{CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary")
			install( CODE "EXECUTE_PROCESS(COMMAND mkdir ${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary)" )
		endif()
		#symlink the folders inside SCCLassLibrary. Check if QtCollider folder should be symlinked or not.
		file(GLOB classlibraryfolders RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/SCClassLibrary" "SCClassLibrary/[^.]*")
		foreach(onedirectory ${classlibraryfolders})
			if(NOT "${onedirectory}" MATCHES "${SCCLASSLIB_EXCLUDE_REGEX}")
				install( CODE
					"EXECUTE_PROCESS(COMMAND ln -shF ${CMAKE_CURRENT_SOURCE_DIR}/SCClassLibrary/${onedirectory} ${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary/${onedirectory} )" )
			endif()
		endforeach(onedirectory)
	else()
		message(STATUS "Will copy SCCLassLibrary to ${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}")

		#if directory contains symlinks, unlink them.
		if(EXISTS "${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary")
			file(GLOB classlibraryfolders "${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary/[^.]*")
			foreach(onedirectory ${classlibraryfolders})
				if(IS_SYMLINK "${onedirectory}")
					message(STATUS "Unlinking ${onedirectory}")
					install( CODE "EXECUTE_PROCESS(COMMAND unlink ${onedirectory} )" )
				endif()
			endforeach(onedirectory)
		endif()

		install(DIRECTORY SCClassLibrary
			DESTINATION ${auxresourcesdir}
			REGEX ${SCCLASSLIB_EXCLUDE_REGEX} EXCLUDE
		)
	endif()
else()
	install(DIRECTORY SCClassLibrary
		DESTINATION ${auxresourcesdir}
		REGEX ${SCCLASSLIB_EXCLUDE_REGEX} EXCLUDE
		PATTERN "*~" EXCLUDE
		PATTERN "*#" EXCLUDE
	)
endif()

configure_file(platform/SCVersion.sc.in SCVersion/SCVersion.sc)
install(DIRECTORY "${CMAKE_BINARY_DIR}/SCVersion" DESTINATION "${auxresourcesdir}/SCClassLibrary")

install(DIRECTORY sounds
	DESTINATION ${auxresourcesdir}
)

if(APPLE AND ("${standalone}" STREQUAL ""))
	set(exampledir "${scappbundlename}")
else()
	set(exampledir "${auxresourcesdir}")
endif()

=== QtCollider/CMakeLists.txt ===
find_package (Qt4 4.5 COMPONENTS QtCore QtGui QtWebKit)

if (NOT QT4_FOUND)
    set(FIND_QT_ERROR_MSG "You are trying to compile with Qt GUI support, but a suitable version of Qt or one of its components could not be found:")

    if(NOT QT_QTCORE_FOUND)
      set(FIND_QT_ERROR_MSG "${FIND_QT_ERROR_MSG}\n-- Missing component: QtCore")
    endif()
    if(NOT QT_QTGUI_FOUND)
      set(FIND_QT_ERROR_MSG "${FIND_QT_ERROR_MSG}\n-- Missing component: QtGui")
    endif()
    if(NOT QT_QTWEBKIT_FOUND)
      set(FIND_QT_ERROR_MSG "${FIND_QT_ERROR_MSG}\n-- Missing component: QtWebKit")
    endif()

    set(FIND_QT_ERROR_MSG "${FIND_QT_ERROR_MSG}\nPlease either install Qt (version 4.5 or greater), or compile without Qt GUI support (add -DSC_QT=OFF to the cmake command line).")

    message(FATAL_ERROR ${FIND_QT_ERROR_MSG})
endif()

set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}  -DQC_DEBUG")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -DQC_DEBUG")

set(QT_COLLIDER_DIR ${CMAKE_SOURCE_DIR}/QtCollider)

set( QT_COLLIDER_HDRS
  ${QT_COLLIDER_DIR}/QcApplication.h
  ${QT_COLLIDER_DIR}/QObjectProxy.h
  ${QT_COLLIDER_DIR}/QWidgetProxy.h
  ${QT_COLLIDER_DIR}/widgets/BasicWidgets.h
  ${QT_COLLIDER_DIR}/widgets/QcTreeWidget.h
  ${QT_COLLIDER_DIR}/widgets/QcScrollArea.h
  ${QT_COLLIDER_DIR}/widgets/QcNumberBox.h
  ${QT_COLLIDER_DIR}/widgets/QcSlider.h
  ${QT_COLLIDER_DIR}/widgets/QcSlider2D.h
  ${QT_COLLIDER_DIR}/widgets/QcRangeSlider.h
  ${QT_COLLIDER_DIR}/widgets/QcMultiSlider.h
  ${QT_COLLIDER_DIR}/widgets/QcKnob.hpp
  ${QT_COLLIDER_DIR}/widgets/QcTextEdit.h
  ${QT_COLLIDER_DIR}/widgets/QcScope.h
  ${QT_COLLIDER_DIR}/widgets/QcScopeShm.h
  ${QT_COLLIDER_DIR}/widgets/QcGraph.h
  ${QT_COLLIDER_DIR}/widgets/QcLevelIndicator.h
  ${QT_COLLIDER_DIR}/widgets/QcCanvas.h
  ${QT_COLLIDER_DIR}/widgets/soundfileview/view.hpp
  ${QT_COLLIDER_DIR}/widgets/QcFileDialog.h
  ${QT_COLLIDER_DIR}/widgets/QcPenPrinter.h
  ${QT_COLLIDER_DIR}/widgets/QcWebView.h
  ${QT_COLLIDER_DIR}/widgets/QcWindow.h
  ${QT_COLLIDER_DIR}/layouts/layouts.hpp
  ${QT_COLLIDER_DIR}/layouts/stack_layout.hpp
  ${QT_COLLIDER_DIR}/style/style.hpp
)

set( QT_COLLIDER_SRCS
  ${QT_COLLIDER_DIR}/debug.cpp
  ${QT_COLLIDER_DIR}/interface.cpp
  ${QT_COLLIDER_DIR}/factories.cpp
  ${QT_COLLIDER_DIR}/QcApplication.cpp
  ${QT_COLLIDER_DIR}/Common.cpp
  ${QT_COLLIDER_DIR}/QObjectProxy.cpp
  ${QT_COLLIDER_DIR}/QWidgetProxy.cpp
  ${QT_COLLIDER_DIR}/Slot.cpp
  ${QT_COLLIDER_DIR}/QcObjectFactory.cpp
  ${QT_COLLIDER_DIR}/hacks/hacks_x11.cpp
  ${QT_COLLIDER_DIR}/primitives/primitives.cpp
  ${QT_COLLIDER_DIR}/primitives/prim_QObject.cpp
  ${QT_COLLIDER_DIR}/primitives/prim_QPen.cpp
  ${QT_COLLIDER_DIR}/primitives/prim_misc.cpp
  ${QT_COLLIDER_DIR}/primitives/prim_QWidget.cpp
  ${QT_COLLIDER_DIR}/primitives/prim_QPalette.cpp
  ${QT_COLLIDER_DIR}/widgets/BasicWidgets.cpp
  ${QT_COLLIDER_DIR}/widgets/QcTreeWidget.cpp
  ${QT_COLLIDER_DIR}/widgets/QcScrollArea.cpp
  ${QT_COLLIDER_DIR}/widgets/QcAbstractStepValue.cpp
  ${QT_COLLIDER_DIR}/widgets/QcNumberBox.cpp
  ${QT_COLLIDER_DIR}/widgets/QcSlider.cpp
  ${QT_COLLIDER_DIR}/widgets/QcSlider2D.cpp
  ${QT_COLLIDER_DIR}/widgets/QcRangeSlider.cpp
  ${QT_COLLIDER_DIR}/widgets/QcMultiSlider.cpp
  ${QT_COLLIDER_DIR}/widgets/QcKnob.cpp
  ${QT_COLLIDER_DIR}/widgets/QcTextEdit.cpp
  ${QT_COLLIDER_DIR}/widgets/QcScope.cpp
  ${QT_COLLIDER_DIR}/widgets/QcScopeShm.cpp
  ${QT_COLLIDER_DIR}/widgets/QcLevelIndicator.cpp
  ${QT_COLLIDER_DIR}/widgets/QcWindow.cpp
  ${QT_COLLIDER_DIR}/widgets/QcGraph.cpp
  ${QT_COLLIDER_DIR}/widgets/QcCanvas.cpp
  ${QT_COLLIDER_DIR}/widgets/soundfileview/view.cpp
  ${QT_COLLIDER_DIR}/widgets/soundfileview/filestream.cpp
  ${QT_COLLIDER_DIR}/widgets/soundfileview/cachestream.cpp
  ${QT_COLLIDER_DIR}/widgets/QcFileDialog.cpp
  ${QT_COLLIDER_DIR}/widgets/QcPenPrinter.cpp
  ${QT_COLLIDER_DIR}/widgets/QcWebView.cpp
  ${QT_COLLIDER_DIR}/layouts/classic_layouts.cpp
  ${QT_COLLIDER_DIR}/layouts/layouts.cpp
  ${QT_COLLIDER_DIR}/layouts/stack_layout.cpp
  ${QT_COLLIDER_DIR}/style/ProxyStyle.cpp
  ${QT_COLLIDER_DIR}/style/style.cpp
)

if(QT_COLLIDER_LANG_CLIENT)
    list(APPEND QT_COLLIDER_HDRS ${QT_COLLIDER_DIR}/LanguageClient.h)
    list(APPEND QT_COLLIDER_SRCS ${QT_COLLIDER_DIR}/LanguageClient.cpp)
endif()

if(APPLE)
  set( QT_COLLIDER_OBJCPP_SRCS
      ${QT_COLLIDER_DIR}/hacks/hacks_mac.M
  )
endif()

if( CMAKE_COMPILER_IS_GNUCXX )
  set_source_files_properties( ${QT_COLLIDER_OBJCPP_SRCS}
      PROPERTIES COMPILE_FLAGS "-x objective-c++ -fobjc-exceptions"
  )
endif()

include(${QT_USE_FILE})

set( SC_HEADERS_DIR "${CMAKE_SOURCE_DIR}/include" )
include_directories(
  "${SC_HEADERS_DIR}/QtCollider"
)

qt4_wrap_cpp( QT_COLLIDER_MOC_SRCS ${QT_COLLIDER_HDRS} )
qt4_add_resources( QT_COLLIDER_RCC ${QT_COLLIDER_DIR}/resources.qrc )

list( APPEND QT_COLLIDER_SRCS
  ${QT_COLLIDER_OBJCPP_SRCS}
  ${QT_COLLIDER_MOC_SRCS}
  ${QT_COLLIDER_RCC}
)

add_definitions(-DSC_QT -DQT_COLLIDER_EXPORTING -DQT_NO_KEYWORDS)

set (QT_COLLIDER_LIBS ${QT_LIBRARIES} ${MATH_LIBRARY})

if(APPLE)
  list(APPEND QT_COLLIDER_LIBS "-framework Cocoa" )
endif()

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
	find_package(X11)

	if(X11_FOUND)
		include_directories(X11_INCLUDE_DIR)
		list(APPEND QT_COLLIDER_LIBS ${X11_X11_LIB})
	elseif()
		message(SEND_ERROR "Cannot find libx11")
	endif()
endif()

=== bindings/CMakeLists.txt ===
if (SC_PSYCOLLIDER)
	add_subdirectory(PySCLang)
endif()

=== editors/CMakeLists.txt ===

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	option(SC_EL "Build emacs-based IDE." ON)
    option(SC_ED "Build gedit-based IDE." ON)
    option(SC_VIM "Build vim-based IDE." ON)
else()
	option(SC_EL "Build emacs-based IDE." OFF)
    option(SC_ED "Build gedit-based IDE." OFF)
    option(SC_VIM "Build vim-based IDE." OFF)
endif()


if(SC_EL)
	add_subdirectory(scel)
endif()

if(SC_ED)
	add_subdirectory(sced)
endif()

if(SC_VIM)
	add_subdirectory(scvim)
endif()

if(SC_PSYCOLLIDER)
	add_subdirectory(Psycollider)
endif()

=== external_libraries/CMakeLists.txt ===
if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/nova-simd/vec.hpp)
	message(FATAL_ERROR "nova-simd submodule is missing: please run `git submodule init && git submodule update' from the toplevel of your git working tree")
endif()

if(NOT Boost_FOUND) # we compile boost ourselves
	# boost thread
	aux_source_directory(boost/libs/thread/src/ boost_thread_src )

	include_directories(boost)

	if(WIN32)
		aux_source_directory(boost/libs/thread/src/win32/ boost_thread_platform )
		add_definitions(-DBOOST_THREAD_BUILD_LIB)
	elseif(PTHREADS_FOUND)
		aux_source_directory(boost/libs/thread/src/pthread/ boost_thread_platform )
	else()
		message(SEND_ERROR "we need to implement boost_thread")
	endif()

	include_directories(${PTHREADS_INCLUDE_DIR})

	if (SUPERNOVA)
		aux_source_directory(boost/libs/program_options/src/ boost_program_options )
		add_library(boost_program_options STATIC ${boost_program_options})

		aux_source_directory(boost/libs/system/src/ boost_system )
		add_library(boost_system STATIC ${boost_system})

		aux_source_directory(boost/libs/filesystem/v3/src boost_filesystem_v3)
		add_library(boost_filesystem STATIC ${boost_filesystem_v2} ${boost_filesystem_v3})

		if(LTO)
			set_property(TARGET boost_program_options boost_system boost_filesystem
						 APPEND PROPERTY COMPILE_FLAGS "-flto -flto-report")

			set_property(TARGET boost_program_options boost_system boost_filesystem
						 APPEND PROPERTY LINK_FLAGS "-flto -flto-report")
		endif()
	endif()

	if (${DSO_VISIBILITY})
		remove_definitions(-fvisibility=hidden)
	endif()

	add_library(boost_thread STATIC ${boost_thread_src} ${boost_thread_platform})

	if(LTO)
		set_property(TARGET boost_thread
					APPEND PROPERTY COMPILE_FLAGS "-flto -flto-report")

		set_property(TARGET boost_thread
					APPEND PROPERTY LINK_FLAGS "-flto -flto-report")
	endif()
endif()

if (SUPERNOVA)
	#oscpack
	add_library(oscpack STATIC "oscpack_build.cpp")

	#tlsf
	add_library(tlsf STATIC "TLSF-2.4.6/src/tlsf.c")
	set_target_properties(tlsf
						 PROPERTIES COMPILE_DEFINITIONS TLSF_STATISTIC=1)
	if(LTO)
		set_property(TARGET oscpack tlsf
					 APPEND PROPERTY COMPILE_FLAGS "-flto -flto-report")

		set_property(TARGET oscpack tlsf
					 APPEND PROPERTY LINK_FLAGS "-flto -flto-report")
	endif()
endif()

=== lang/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/include/common
                    ${CMAKE_SOURCE_DIR}/include/lang
                    ${CMAKE_SOURCE_DIR}/include/plugin_interface
                    ${CMAKE_SOURCE_DIR}/include/server
                    ${CMAKE_SOURCE_DIR}/external_libraries/boost_lockfree
                    ${CMAKE_SOURCE_DIR}/external_libraries/threadpool
                    ${CMAKE_SOURCE_DIR}/external_libraries/yaml-cpp-0.3.0/include
                    ${CMAKE_SOURCE_DIR}/external_libraries/TLSF-2.4.6/src
                    LangSource/Bison)

if (Boost_FOUND)
    include_directories(${Boost_INCLUDE_DIRS})
else()
    include_directories(${CMAKE_SOURCE_DIR}/external_libraries/boost)
endif()

if(APPLE)
	include_directories("LangPrimSource/${HID_UTIL_DIR}")
elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
	find_package(ALSA)
elseif(WIN32)
	find_package(Portmidi)
endif()

find_package(Readline 5.0)

find_package(Sndfile)

set(sclang_sources
	LangPrimSource/SC_Wii.cpp
	LangPrimSource/PyrSignalPrim.cpp
	LangPrimSource/PyrSched.cpp
	LangPrimSource/PyrPrimitive.cpp
	LangPrimSource/PyrMathPrim.cpp
	LangPrimSource/SC_ComPort.cpp
	LangPrimSource/OSCData.cpp
	LangPrimSource/PyrArchiver.cpp
	LangPrimSource/PyrArrayPrimitives.cpp
	LangPrimSource/PyrBitPrim.cpp
	LangPrimSource/PyrCharPrim.cpp
	LangPrimSource/PyrFilePrim.cpp
	LangPrimSource/PyrListPrim.cpp
	LangPrimSource/PyrPlatformPrim.cpp
	LangPrimSource/PyrStringPrim.cpp
	LangPrimSource/PyrSymbolPrim.cpp
	LangPrimSource/PyrUnixPrim.cpp
	LangSource/AdvancingAllocPool.cpp
	LangSource/ByteCodeArray.cpp
	LangSource/DumpParseNode.cpp
	LangSource/GC.cpp
	LangSource/InitAlloc.cpp
	LangSource/PyrFileUtils.cpp
	LangSource/PyrInterpreter3.cpp
	LangSource/PyrLexer.cpp
	LangSource/PyrMathOps.cpp
	LangSource/PyrMathSupport.cpp
	LangSource/PyrMessage.cpp
	LangSource/PyrObject.cpp
	LangSource/PyrParseNode.cpp
	LangSource/PyrSignal.cpp
	LangSource/PyrSymbolTable.cpp
	LangSource/SC_LanguageClient.cpp
	LangSource/SC_LibraryConfig.cpp
	LangSource/SC_TerminalClient.cpp
	LangSource/Samp.cpp
	LangSource/SimpleStack.cpp
	LangSource/VMGlobals.cpp
	LangSource/dumpByteCodes.cpp

	${CMAKE_SOURCE_DIR}/common/fftlib.c
	${CMAKE_SOURCE_DIR}/common/SC_AllocPool.cpp
	${CMAKE_SOURCE_DIR}/common/SC_DirUtils.cpp
	${CMAKE_SOURCE_DIR}/common/SC_Sem.cpp
	${CMAKE_SOURCE_DIR}/common/SC_StandAloneInfo_Darwin.cpp
	${CMAKE_SOURCE_DIR}/common/SC_StringBuffer.cpp
	${CMAKE_SOURCE_DIR}/common/SC_StringParser.cpp
	${CMAKE_SOURCE_DIR}/common/scsynthsend.cpp
	${CMAKE_SOURCE_DIR}/common/sc_popen.cpp
)

if (NOT Boost_FOUND)
	file(GLOB boost_system_sources ../external_libraries/boost/libs/system/src/*cpp)
	file(GLOB boost_fs_sources ../external_libraries/boost/libs/filesystem/v3/src/*cpp)
	file(GLOB boost_regex_sources ../external_libraries/boost/libs/regex/src/*cpp)
	list(APPEND sclang_sources ${boost_fs_sources} ${boost_system_sources} ${boost_regex_sources})
endif()

file(GLOB yaml_sources ../external_libraries/yaml-cpp-0.3.0/src/*cpp)
list(APPEND sclang_sources ${yaml_sources})

if(NOT WIN32)
	list(APPEND sclang_sources LangPrimSource/PyrSerialPrim.cpp)
endif()

if(WIN32)
	list(APPEND sclang_sources ${CMAKE_SOURCE_DIR}/common/SC_Win32Utils.cpp)
endif()

if(WIN32)
	include_directories(../platform/windows/compat_stuff)
	list(APPEND sclang_sources ../platform/windows/compat_stuff/getopt.c)
endif()

set(sclang_parser_source LangSource/Bison/lang11d_tab.cpp)

add_definitions(-DYYSTACK_USE_ALLOCA)

if(UNIX)
	if(APPLE)
		list(APPEND sclang_sources
			LangPrimSource/WiiMote_OSX/wiiremote.c
			LangPrimSource/SC_HID.cpp
			LangPrimSource/${HID_UTIL_DIR}/HID_Utilities.c
			LangPrimSource/${HID_UTIL_DIR}/HID_Name_Lookup.c
			LangPrimSource/${HID_UTIL_DIR}/HID_Queue_Utilities.c
			LangPrimSource/${HID_UTIL_DIR}/HID_Error_Handler.c
			LangPrimSource/SC_CoreMIDI.cpp
			LangPrimSource/SC_CoreAudioPrim.cpp
			LangPrimSource/SC_Speech.M
			)
		add_definitions(-DHAVE_SPEECH)
		if (CMAKE_COMPILER_IS_GNUCXX)
			set_source_files_properties(LangPrimSource/SC_Speech.M
										PROPERTIES COMPILE_FLAGS "-x objective-c++ -fobjc-exceptions")
		endif()
		if(NOT (HID_UTIL_DIR MATCHES "HID_Utilities_10_4"))
			list(APPEND sclang_sources
				LangPrimSource/${HID_UTIL_DIR}/IOHIDElement_.c
				LangPrimSource/${HID_UTIL_DIR}/IOHIDDevice_.c
			)
		endif()
	else(APPLE)
		if(ALSA_FOUND)
			list(APPEND sclang_sources LangPrimSource/SC_AlsaMIDI.cpp)
		endif()
		list(APPEND sclang_sources LangPrimSource/SC_LID.cpp)
		add_definitions(-DHAVE_LID)
	endif(APPLE)
else(UNIX)
endif(UNIX)

if(WIN32)
	include_directories (../platform/windows/compat_stuff)
	list(APPEND sclang_sources ../platform/windows/compat_stuff/getopt.c)
	if(PORTMIDI_FOUND)
		include_directories (${PORTMIDI_INCLUDE_DIRS})
		add_definitions(-DHAVE_PORTMIDI)
		list(APPEND sclang_sources LangPrimSource/SC_PortMidi.cpp)
	endif()
endif()

if (SC_WII OR APPLE)
	if(CMAKE_SYSTEM_NAME MATCHES "Linux")
		find_package(CWiid)
		find_package(Bluetooth)

		if (BLUETOOTH_FOUND AND CWIID_FOUND)
			add_definitions(-DHAVE_WII)
			include_directories(${CWIID_INCLUDE_DIRS} ${BLUETOOTH_INCLUDE_DIRS})
			message(STATUS "Compiling with WiiMote support")
		else()
			message(SEND_ERROR "Cannot find libcwiid or libbluetooth")
		endif()
	elseif(APPLE)
		add_definitions(-DHAVE_WII)
		list(APPEND sclang_sources LangPrimSource/WiiMote_OSX/wiiremote.c)
		include_directories(LangPrimSource/WiiMote_OSX)
	endif()
endif()

include(../SCDoc/CMakeLists.txt)
list(APPEND sclang_sources ${SCDOC_SRCS})


if(SC_QT)
	set(QT_COLLIDER_LANG_CLIENT ON)
	include(../QtCollider/CMakeLists.txt)
	list(APPEND sclang_sources ${QT_COLLIDER_SRCS})
endif()

if(0 AND FINAL_BUILD) # sclang final-builds are broken
	CREATE_FINAL_FILE(libsclang_final.cpp ${sclang_sources})
	add_library(libsclang SHARED libsclang_final.cpp ${sclang_parser_source})
else()
	add_library(libsclang STATIC ${sclang_sources} ${sclang_parser_source})
endif()

set_property(TARGET libsclang
	APPEND
	PROPERTY COMPILE_DEFINITIONS BUILDING_SUPERCOLLIDER)

if (SC_WII OR APPLE)
	if (BLUETOOTH_FOUND AND CWIID_FOUND)
		target_link_libraries(libsclang ${BLUETOOTH_LIBRARIES} ${CWIID_LIBRARIES})
	elseif(APPLE)
		target_link_libraries(libsclang "-framework IOBluetooth")
	endif()
endif()

if (Boost_FOUND)
	target_link_libraries(libsclang ${Boost_THREAD_LIBRARY} ${Boost_SYSTEM_LIBRARY} ${Boost_REGEX_LIBRARY} ${Boost_FILESYSTEM_LIBRARY})
endif()

if (SCLANG_SERVER)
	target_link_libraries(libsclang libscsynth)
else()
	set_property(TARGET libsclang
		APPEND
		PROPERTY COMPILE_DEFINITIONS NO_INTERNAL_SERVER
		)
endif()


set_property(TARGET libsclang
	PROPERTY OUTPUT_NAME sclang)


## external libraries
if(READLINE_FOUND)
	message(STATUS "Compiling with Readline support")
	set_property(TARGET libsclang
		APPEND
		PROPERTY COMPILE_DEFINITIONS HAVE_READLINE)
	include_directories(${READLINE_INCLUDE_DIR})
	target_link_libraries(libsclang ${READLINE_LIBRARY})
endif(READLINE_FOUND)

if (APPLE)
	target_link_libraries(libsclang "-framework Carbon")
	target_link_libraries(libsclang "-framework CoreAudio")
	target_link_libraries(libsclang "-framework CoreMIDI")
	target_link_libraries(libsclang "-framework IOKit")
	target_link_libraries(libsclang "-framework CoreServices")
endif()

if(ALSA_FOUND)
	message(STATUS "Compiling with ALSA midi support")
	set_property(TARGET libsclang
		APPEND
		PROPERTY COMPILE_DEFINITIONS HAVE_ALSA=1)
	target_link_libraries(libsclang ${ALSA_LIBRARY})
endif(ALSA_FOUND)

if(SNDFILE_FOUND)
	include_directories(${SNDFILE_INCLUDE_DIR})
	target_link_libraries(libsclang ${SNDFILE_LIBRARIES})
elseif(NOT NO_LIBSNDFILE)
	message(SEND_ERROR "Cannot find libsndfile")
endif(SNDFILE_FOUND)

if (FFTW3F_FOUND)
	include_directories (${FFTW3F_INCLUDE_DIR})
	target_link_libraries(libsclang ${FFTW3F_LIBRARY})
endif()

if (WIN32)
	target_link_libraries(libsclang wsock32 ws2_32)
	if(PORTMIDI_FOUND)
		target_link_libraries(libsclang ${PORTMIDI_LIBRARIES})
	endif()
endif()

if (GC_SANITYCHECK)
	add_definitions(-DGC_SANITYCHECK)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	target_link_libraries(libsclang rt)
endif()

target_link_libraries(libsclang ${PTHREADS_LIBRARY})

if(SC_QT)
	target_link_libraries(libsclang ${QT_COLLIDER_LIBS})
endif()

add_executable(sclang LangSource/cmdLineFuncs.cpp)

if (Boost_FOUND)
	target_link_libraries(sclang libsclang ${Boost_THREAD_LIBRARY})
else()
	target_link_libraries(sclang libsclang boost_thread)
endif()

set_property(TARGET sclang
	APPEND
	PROPERTY COMPILE_DEFINITIONS USE_SC_TERMINAL_CLIENT)

if(LTO)
	set_property(TARGET sclang libsclang
					APPEND PROPERTY COMPILE_FLAGS "-flto -flto-report")

	set_property(TARGET sclang libsclang
					APPEND PROPERTY LINK_FLAGS "-flto -flto-report -fwhole-program")
endif()

if(APPLE)
	# determines the app name and app install location (scappbundlename, scappdir):
	include (${CMAKE_SOURCE_DIR}/cmake_modules/MacAppFolder.cmake)

	install(TARGETS sclang
			DESTINATION "${scappauxresourcesdir}"
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
elseif(WIN32)
	install(TARGETS sclang
			DESTINATION "SuperCollider"
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
else()
	install(TARGETS sclang
			LIBRARY DESTINATION "lib"
			RUNTIME DESTINATION "bin"
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
endif()

=== platform/CMakeLists.txt ===
if(APPLE)
	add_subdirectory(mac)
elseif(WIN32)
    add_subdirectory(windows)
endif()

# NB freebsd currently OK to ride on linux for this subdir. eventually may need separating.
if(CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
	add_subdirectory(linux)
endif()

=== server/CMakeLists.txt ===
if (NOT APPLE AND NOT WIN32)
	# on apple we leave this undefined so it defaults to .scx (in the code)
	add_definitions("-DSC_PLUGIN_EXT=\".so\"")
endif()

include_directories(${CMAKE_SOURCE_DIR}/external_libraries
					${CMAKE_SOURCE_DIR}/external_libraries/boost_lockfree
					${CMAKE_SOURCE_DIR}/external_libraries/nova-simd
					${CMAKE_SOURCE_DIR}/external_libraries/nova-tt
					)


if (Boost_FOUND)
	include_directories(${Boost_INCLUDE_DIRS})
else()
	include_directories(${CMAKE_SOURCE_DIR}/external_libraries/boost)
endif()


add_subdirectory(plugins)
add_subdirectory(scsynth)

if (SUPERNOVA)
	add_subdirectory(supernova)
endif()

=== bindings/PySCLang/CMakeLists.txt ===
find_package(PythonLibs)

set(pycxxdir ${CMAKE_SOURCE_DIR}/external_libraries/pycxx-6.2.2)

set(PySCLangSource
	${pycxxdir}/Src/cxx_extensions.cxx
	${pycxxdir}/Src/cxxextensions.c
	${pycxxdir}/Src/cxxsupport.cxx
	${pycxxdir}/Src/IndirectPythonInterface.cxx

	PySCLang_Module.cpp
	PySCLang_Module_GUIStuff.cpp
	PySCLang_vpost_stuff.cpp
)

if(WIN32)
	list(APPEND PySCLangSource PySCLang.cpp)
endif()

include_directories(${PYTHON_INCLUDE_PATH})
include_directories(${pycxxdir})

include_directories(${CMAKE_SOURCE_DIR}/include/common
					${CMAKE_SOURCE_DIR}/include/lang
					${CMAKE_SOURCE_DIR}/include/plugin_interface
					${CMAKE_SOURCE_DIR}/editors/scapp/include
				   )

add_library(PySCLang MODULE ${PySCLangSource})
set_target_properties(PySCLang
					  PROPERTIES LINKER_LANGUAGE C
								 PREFIX ""
								 SUFFIX .pyd)

target_link_libraries(PySCLang ${PYTHON_LIBRARY})
target_link_libraries(PySCLang libsclang)

if (WIN32)
	install(TARGETS PySCLang
		DESTINATION "SuperCollider")

	install(FILES ${PYTHON_LIBRARY}
		DESTINATION "SuperCollider")

elseif (CMAKE_SYSTEM_NAME MATCHES "Linux")
	find_package(PythonInterp)

	execute_process ( COMMAND ${PYTHON_EXECUTABLE} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()"
		OUTPUT_VARIABLE PYTHON_SITE_PACKAGES OUTPUT_STRIP_TRAILING_WHITESPACE)

	install(TARGETS PySCLang DESTINATION ${PYTHON_SITE_PACKAGES})
endif()

=== editors/sced/CMakeLists.txt ===
set(SC_ED_VERSIONS 2 3)

list(FIND SC_ED_VERSIONS ${SC_ED} SC_ED_VERSION)

if(SC_ED_VERSION EQUAL -1)
    set(SC_ED 3)
endif()

if(NOT WIN32 AND SC_ED EQUAL 2)

    message(STATUS "Building with Sced for gedit 2 (UNIX)")

    install(FILES data/supercollider.lang
            DESTINATION share/gtksourceview-2.0/language-specs)

    install(FILES data/supercollider.xml
            DESTINATION share/mime/packages)

    install(FILES data/sced.gedit-plugin
            DESTINATION lib/gedit-2/plugins)

    install(DIRECTORY sced
            DESTINATION lib/gedit-2/plugins)

elseif(NOT WIN32 AND SC_ED EQUAL 3)

    message(STATUS "Building with Sced for gedit 3 (UNIX)")

    configure_file(sced3/supercollider.plugin.in sced3/supercollider.plugin)

    install(FILES data/supercollider.lang
            DESTINATION share/gtksourceview-3.0/language-specs)

    install(FILES data/supercollider.xml
            DESTINATION share/mime/packages)

    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/sced3/supercollider.plugin sced3/supercollider.py
            DESTINATION lib/gedit/plugins)

elseif(WIN32)

    message(STATUS "Building with Sced for gedit 2 (Windows)")
    add_subdirectory(scedwin)

endif()

=== external_libraries/boost_lockfree/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (boost-lockfree)

enable_testing()

include_directories(.)

add_subdirectory (libs/lockfree/doc)
add_subdirectory (libs/lockfree/examples)
add_subdirectory (libs/lockfree/test)

=== external_libraries/nova-tt/CMakeLists.txt ===
PROJECT(nova-tt)
cmake_minimum_required(VERSION 2.6)

enable_testing()

include_directories (boost_lockfree)
include_directories (nova-tt)

find_library(pthread pthread)
add_subdirectory (testsuite)

=== debian/changelog ===
supercollider (1:3.5.3~repack-3) unstable; urgency=low

  * Avoid FTBFS in PowerPC
  * Avoid FTBFS in ia64
  * Fix ARM FTBFS: more qreal->double assumptions. Closes: #682361

 -- Felipe Sateler <fsateler@debian.org>  Sat, 28 Jul 2012 20:19:58 -0400

supercollider (1:3.5.3~repack-2) unstable; urgency=low

  [ Dan Stowell ]
  * Fix build on ia64 - avoid invoking unneeded perf_counter.hpp
  * Fix caps in supercollider-emacs remove script. Closes: #681187
  * Boost-atomic build fix for PPC
  * Note copyright for file adapted from wmctrl project
  * Strip accidental gremlin characters that can cause problems for users in
    some locales

  [ Felipe Sateler ]
  * Fix FTBFS in big endian architectures
  * Fix FTBFS in arm* architectures

 -- Dan Stowell <danstowell@users.sourceforge.net>  Thu, 12 Jul 2012 22:53:55 +0100

supercollider (1:3.5.3~repack-1) unstable; urgency=low


  [ Dan Stowell ]
  * Imported upstream version 3.5.3
   -  Removed 3 patches now upstreamed
   - Repack upstream source without boost sources
  * Fix build on non-x86/64: define BOOST_LOCKFREE_DCAS_ALIGNMENT
      (Update prefix.hpp to current boost SVN 2012-07-03)

  [ Jonas Smedegaard ]
  * Unfuzz patch and refresh with shortening options.
  * Revive copyright/license tracking silently dropped in 1:3.5.1-1.

  [ Felipe Sateler ]
  * Add missing epoch to versioned breaks/replaces. Closes: #679705
  * Install README.extensions via debian/rules instead of a patch
  * Add DEP3 header to update_boostlockfree_prefixhpp.patch
  * Remove unused License paragraph
  * Bump Standards-Version (no changes needed)
  * Remove unused lintian override package-contains-empty-directory
  * Update copyright hints file

 -- Felipe Sateler <fsateler@debian.org>  Sat, 07 Jul 2012 14:16:59 -0400

=== debian/control ===
Source: supercollider
Section: sound
Priority: optional
Vcs-Git: git://git.debian.org/pkg-multimedia/supercollider.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/supercollider.git;a=summary
Maintainer: Debian Multimedia Packages Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Quessy <alexandre@quessy.net>,
 Dan Stowell <danstowell@users.sourceforge.net>,
 Felipe Sateler <fsateler@debian.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs (>= 0.4.73~),
 cmake,
 debhelper,
 dh-linktree,
 libjs-mathjax,
 emacs23 | emacsen,
 libasound2-dev [linux-any],
 libavahi-client-dev,
 libcwiid-dev,
 libfftw3-dev,
 libicu-dev,
 libjack-dev,
 libqt4-dev,
 libqtwebkit-dev,
 libreadline-dev,
 libsndfile1-dev (>= 1.0.16),
 libxt-dev,
 python-all-dev (>= 2.6.6-3~),
 qt4-dev-tools,
 libboost-dev (>= 1.48),
 libboost-date-time-dev (>= 1.48),
 libboost-filesystem-dev (>= 1.48),
 libboost-math-dev (>= 1.48),
 libboost-program-options-dev (>=1.48),
 libboost-regex-dev (>= 1.48),
 libboost-system-dev (>=1.48),
 libboost-thread-dev (>=1.48)
Standards-Version: 3.9.3
Homepage: http://supercollider.sourceforge.net/

Package: supercollider
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 libscsynth1 (= ${binary:Version}),
 supercollider-common (= ${source:Version}),
 supercollider-server (= ${binary:Version}),
Suggests: subversion, rsync
Description: real time audio synthesis programming language
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the language interpreter.

Package: supercollider-common
Architecture: all
Depends: ${misc:Depends}
Breaks: supercollider-server (<< 1:3.5)
Replaces: supercollider-doc, supercollider-server (<< 1:3.5)
Description: common files for SuperCollider
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the architecture independent files for SuperCollider.

Package: supercollider-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, jackd
Description: real time audio synthesis server
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the synthesis server.

Package: supercollider-supernova
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, jackd
Description: real time audio synthesis server (multiprocessor version)
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the multiprocessor aware synthesis server supernova.

Package: libscsynth1
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: SuperCollider synthesis server library
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the shared library for the synthesis server.

Package: supercollider-dev
Architecture: any
Depends: ${misc:Depends},
 supercollider (= ${binary:Version}),
 libsndfile1-dev (>= 1.0.16)
Conflicts: supercollider-common-dev,
 supercollider-server-dev
Replaces: supercollider-common-dev,
 supercollider-server-dev
Provides: supercollider-common-dev,
 supercollider-server-dev
Description: development files for SuperCollider
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the development files and headers.

Package: supercollider-emacs
Architecture: all
Depends: ${misc:Depends},
  supercollider (>= ${source:Version}),
  emacs23 | emacsen
Recommends: w3m-el
Description: SuperCollider mode for Emacs
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package provides the SuperCollider mode for Emacs.

Package: supercollider-vim
Architecture: all
Depends: ${misc:Depends},
 supercollider (>= ${source:Version}),
 vim | gvim,
 ruby
Recommends: unhtml | links,
 vim-addon-manager
Suggests: unrtf
Description: SuperCollider mode for Vim
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package provides the SuperCollider mode for Vim.


Package: supercollider-gedit
Architecture: all
Depends: ${misc:Depends},
  supercollider (>= ${source:Version}),
  gedit (>=3.0.0)
Description: SuperCollider mode for Gedit
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package provides the SuperCollider mode for Gedit.

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/cdbs/1/rules/upstream-tarball.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_DH_INSTALL_SOURCEDIR=debian/tmp

# # Add here any variable or target overrides you need.

DEB_INSTALL_DOCS_supercollider             = README_LINUX.txt README.txt
DEB_INSTALL_DOCS_supercollider-server      = README_LINUX.txt README.txt
DEB_INSTALL_DOCS_supercollider-emacs       = editors/scel/README
DEB_INSTALL_DOCS_supercollider-vim         = editors/scvim/README editors/scvim/SCVim.scd
DEB_INSTALL_DOCS_supercollider-gedit       = editors/sced/README

DEB_INSTALL_MANPAGES_supercollider-server  = debian/scsynth.1
DEB_INSTALL_MANPAGES_supercollider-supernova = debian/supernova.1
DEB_INSTALL_MANPAGES_supercollider         = debian/sclang.1
DEB_INSTALL_MANPAGES_supercollider-vim     = debian/scvim.1 debian/sclangpipe_app.1

DEB_CMAKE_EXTRA_FLAGS = -DDSO_VISIBILITY=on -DSUPERNOVA=on -DSC_EL_BYTECOMPILE=OFF

# Exclude external libs from the source package if unused on linux or using system-supplied
DEB_UPSTREAM_REPACKAGE_EXCLUDES = \
				  external_libraries/boost/ \
				  external_libraries/curl/ \
				  external_libraries/libsndfile/ \
				  external_libraries/sndfile.hh \
				  external_libraries/simplejson-*/ \
				  external_libraries/icu
DEB_UPSTREAM_URL = http://prdownloads.sourceforge.net/supercollider
DEB_UPSTREAM_TARBALL_BASENAME_MANGLE = s/supercollider(.*)/SuperCollider$$1-Source-linux/
DEB_UPSTREAM_TARBALL_EXTENSION = tar.bz2
DEB_UPSTREAM_TARBALL_SRCDIR = SuperCollider-Source
DEB_UPSTREAM_TARBALL_MD5 = 84fde920c32e9644902f989136a35b91
DEB_UPSTREAM_REPACKAGE_TAG = repack

binary-fixup/supercollider-common::
	dh_linktree -psupercollider-common

install/supercollider-common::
	install -m 644 debian/README.extensions \
		$(DEB_DH_INSTALL_SOURCEDIR)/usr/share/SuperCollider/Extensions/README

install/supercollider-emacs::
	install -d $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications
	install -m 644 debian/scel.desktop $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications

install/supercollider-vim::
	install -d $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications
	install -m 644 debian/scvim.desktop $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications

=== debian/watch ===
version=3

#opts=dversionmangle=s/\.\d~\w+$//,uversionmangle=s/RC\d+$// \
#  http://sf.net/supercollider/SuperCollider-(.*)\-Source.tar\.gz

# better manglers, provided by Dan Stowell
opts=dversionmangle=s/\.\d~\w+$//,uversionmangle=s/([a-zA-Z]+)/~$1/ \
  http://sf.net/supercollider/SuperCollider-(.*)\-Source-linux\.tar\.gz
